# $Id: busybox.make,v 0.3.3.1 2002/09/25 11:00:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
ifeq (y,$(PTXCONF_BUSYBOX))
PACKAGES += busybox
endif

#
# Paths and names 
#
BUSYBOX			= busybox-0.61.pre-ptx1
BUSYBOX_URL		= # there is no official release of busybox 0.61 yet  
BUSYBOX_SOURCE		= $(PTXSRCDIR)/$(BUSYBOX).tgz
BUSYBOX_DIR		= $(BUILDDIR)/$(BUSYBOX)
BUSYBOX_EXTRACT 	= gzip -dc

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

busybox_get: $(STATEDIR)/busybox.get

busybox_get_deps =  $(BUSYBOX_SOURCE)

$(STATEDIR)/busybox.get: $(busybox_get_deps)
	touch $@

$(BUSYBOX_SOURCE):
	@echo
	@echo ----------- 
	@echo busybox.get
	@echo -----------
	@echo
#	wget -P $(SRCDIR) $(PASSIVEFTP) $(BUSYBOX_URL)
	@echo ERROR: busybox source not available in ptx sourcedir
	@exit

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

busybox_extract: $(STATEDIR)/busybox.extract

$(STATEDIR)/busybox.extract: $(STATEDIR)/busybox.get
	@echo
	@echo --------------- 
	@echo busybox.extract
	@echo ---------------
	@echo
	$(BUSYBOX_EXTRACT) $(BUSYBOX_SOURCE) | $(TAR) -C $(BUILDDIR) -xf -
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

busybox_prepare: $(STATEDIR)/busybox.prepare 

BUSYBOX_ENVIRONMENT = 
BUSYBOX_MAKEVARS    =
ifeq (y,$(PTXCONF_ARCH_ARM))
BUSYBOX_ENVIRONMENT += PATH=$(PTXCONF_PREFIX)/bin:$$PATH
BUSYBOX_MAKEVARS    += CROSS=arm-linux-
endif

#
# dependencies
#
busybox_prepare_deps =  $(STATEDIR)/busybox.extract 
ifeq (y,$(PTXCONF_BUILD_CROSSCHAIN))
busybox_prepare_deps += $(STATEDIR)/xchain-gccstage2.install
endif

$(STATEDIR)/busybox.prepare: $(busybox_prepare_deps)
	@echo
	@echo --------------- 
	@echo busybox.prepare
	@echo ---------------
	@echo
	# FIXME: is this necessary? 
	$(BUSYBOX_ENVIRONMENT) make -C $(BUSYBOX_DIR) distclean $(BUSYBOX_MAKEVARS)
	grep PTXCONF_BB_ config/config > $(BUSYBOX_DIR)/.config
	perl -i -p -e 's/PTXCONF_BB_/CONFIG_/g' $(BUSYBOX_DIR)/.config
	$(BUSYBOX_ENVIRONMENT) make -C $(BUSYBOX_DIR) oldconfig $(BUSYBOX_MAKEVARS)
	$(BUSYBOX_ENVIRONMENT) make -C $(BUSYBOX_DIR) dep $(BUSYBOX_MAKEVARS)
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

busybox_compile: $(STATEDIR)/busybox.compile

$(STATEDIR)/busybox.compile: $(STATEDIR)/busybox.prepare 
	@echo
	@echo --------------- 
	@echo "busybox.compile"
	@echo ---------------
	@echo
	$(BUSYBOX_ENVIRONMENT) make -C $(BUSYBOX_DIR) $(BUSYBOX_MAKEVARS)
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

busybox_install: $(STATEDIR)/busybox.install

$(STATEDIR)/busybox.install: $(STATEDIR)/busybox.compile
	@echo
	@echo --------------- 
	@echo busybox.install
	@echo ---------------
	@echo
	touch $@

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

busybox_targetinstall: $(STATEDIR)/busybox.targetinstall

$(STATEDIR)/busybox.targetinstall: $(STATEDIR)/busybox.install
	@echo
	@echo --------------------- 
	@echo busybox.targetinstall
	@echo ---------------------
	@echo
	rm -f $(BUSYBOX_DIR)/busybox.links
	$(BUSYBOX_ENVIRONMENT) make -C $(BUSYBOX_DIR) install 		\
		PREFIX=$(ROOTDIR) $(BUSYBOX_MAKEVARS)
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

busybox_clean: 
	-rm -rf $(STATEDIR)/busybox* 
	-rm -rf $(BUSYBOX_DIR) 

# vim: syntax=make
